# CovidAlertVaccinationModel

This repo contains two packages:

* CovidAlertVaccinationModel


* ZeroWeightedDistributions

The former implements the ABM, and computes approximations for the age-structured contact time distributions.  The latter package, ZeroWeightedDistributions, implements a helpful type ZWDist{D} representing a random variable of distribution D with added weight at zero.

# Installation

First, clone this repository and open the Julia-1.6 beta in the active directory
```
git clone https://git.uwaterloo.ca/pjentsch/covidalertabm.git
cd covidalertabm
julia -t auto
```
the `-t auto` option starts Julia with as many threads as you have physical CPU cores. You can pass this option a number if you prefer to use fewer threads.

This should bring you to a julia REPL. Typing `]` at this repl will change your prompt to `pkg>`.

Then add these packages to your main environment:
```
dev ./CovidAlertVaccinationModel
dev ./ZeroWeightedDistributions
```

We need to `dev` each of the above packages because they all share one git repo, and Julia's package manager doesn't seem to like that very much. I suppose we could split them into separate repos in the future.

This package only tested on x86-64 Linux. It should work everywhere that Julia does though. 